# Author: Rick Hofstede, University of Twente <r.j.hofstede@utwente.nl>

#! /usr/bin/env python
# -*- coding: iso-8859-1 -*-

# Measurement script for analyzing TCP FIN/RST flag flow record expiration behavior.
# More details: Section 4 of the following paper:
#       Measurement Artifacts in NetFlow Data
#       Rick Hofstede, Idilio Drago, Anna Sperotto, Ramin Sadre, Aiko Pras.
#       In: Proceedings of the Passive and Active Measurement conference (PAM 2013), 18-20 May 2013, Hong Kong, China

from scapy.all import *

src_host = '<src_ip>' # Enter the source IP address here
dst_host = '<dst_ip>' # Enter the destination address here
src_port = 26662
dst_port = 26662
 
p = IP(src = src_host, dst = dst_host)/TCP(sport = src_port, dport = dst_port)
 
p[TCP].flags = 'S'
send(p)
 
p[TCP].flags = 'A'
for i in range(0, 3):
	send(p)
 
p[TCP].flags = 'F'
send(p)
time.sleep(10)
 
p[TCP].flags = 'S'
send(p)
 
p[TCP].flags = 'A'
for i in range(0, 3):
	send(p)
 
p[TCP].flags = 'R'
send(p)
time.sleep(10)
 
p[TCP].flags = 'S'
send(p)
 
p[TCP].flags = 'A'
for i in range(0, 3):
	send(p)
p[TCP].flags = 'F'
send(p)
